%% Type negation - delay until type T and then die.
%
% not(T) macro not(a_ T).
% fun not(+,-).
% not((a_ T),FS) if when(FS=T,fail).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% compile_rest/[0,1]:  compile everything except the signature
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

compile_rest(File) :-
  abolish(('+++>')/2), abolish((fun)/1), retractall(fun_exp(_,_,_)),
  abolish((macro)/2), abolish(':='/2),
  abolish((trale_cons)/2),abolish((cons)/2),abolish(('*>')/2),
  abolish((if)/2),
  abolish((empty)/1),abolish((rule)/2),
  abolish((lex_rule)/2),
  abolish(('--->')/2),
  abolish((semantics)/1),
  reconsult(File),
  compile_rest.

compile_rest :-
  touch('.alec_throw'),
  absolute_file_name('.alec_throw',AbsFileName),
  retractall(ale_compiling(_)),
  assert(ale_compiling(AbsFileName)),
  compile_fun_act,
  compile_cons_act,
  compile_logic_act,
  compile_subsume_act,
  compile_dcs_act,
  compile_grammar_act,
  retract(ale_compiling(_)).

dcompile_rest(File) :-
  abolish((empty)/1), abolish((rule)/2), abolish((lex_rule)/2), 
  abolish(('--->')/2),
  abolish((if)/2), abolish((':=')/2), abolish((macro)/2),
  abolish((ext)/1), abolish((cons)/2), abolish(('*>')/2),
% 5/1/96 - Octav -- added abolish/2 calls for generation predicates
  abolish((semantics)/1),
  abolish(('+++>')/2),
  abolish((trale_cons)/2),
  abolish('l--->',3),abolish(lif,2),abolish('l+++>',2),abolish(llr,3),
  abolish(lrule,4),abolish(lmacro,2),abolish(lemptyentry,2), abolish(lcons,4),
  abolish(lsemantics,2), abolish(lclosedrule,7), abolish(empty_cat,6),
  retractall(ale_debugging), retractall(ale_debug(_)), abolish(ale_break,1),
  assert(ale_debugging),
  reconsult(File),
  retractall(ale_debugging),
  compile_fun,
  dcompile_cons,
  pcompile_gram2,
  compile_lex_rules,
  assert(d_mode(skip([]))),  % skip all ports during lexicon compilation
  asserta(d_skip_level(0)),  % need asserta/1 for buggy Win32 SICStus  
  compile_lex,
  retractall(d_mode(_)),
  retractall(d_skip_level(_)),
  d_close_emptys_rules.
  
